from CodeWiz.WizSerial import WizSerial
from CodeWiz.WizDefaultSensor import WizSensorData
from CodeWiz import WizData


class _V:
    Sensor= WizSensorData()
    wizSerial=None



class Device:
    Sensor= _V.Sensor

    @staticmethod
    def connect(COM):
        if _V.wizSerial is None:
            _V.wizSerial=WizSerial(COM, _V.Sensor)
            return _V.wizSerial
        else:
            return _V.wizSerial

    @staticmethod
    def disconnect():
        if _V.wizSerial is not None:
            _V.wizSerial.end()
            _V.wizSerial=None

    @staticmethod
    def sensorStart():
        if _V.wizSerial is None:
            raise RuntimeError("Must be connected to CodeWiz")
        _V.wizSerial.runDefaultSensor()

    class Rgb:
        @staticmethod
        def init():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Rgb.init())

        @staticmethod
        def setBrightness(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Rgb.setBrightness(*params))

        @staticmethod
        def setColor(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Rgb.setColor(*params))

        @staticmethod
        def setColorAll(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Rgb.setColorAll(*params))

    class Speaker:
        @staticmethod
        def init():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Speaker.init())

        @staticmethod
        def play(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Speaker.play(*params))

        @staticmethod
        def off():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Speaker.off())

    class Oled:
        @staticmethod
        def init():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.init())

        @staticmethod
        def clear():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.clear())

        @staticmethod
        def reverseMode(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.reverseMode(*params))

        @staticmethod
        def setFontSize(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.setFontSize(*params))

        @staticmethod
        def setCursor(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.setCursor(*params))

        @staticmethod
        def print(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.print(*params))

        @staticmethod
        def printHanguel(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.printHanguel(*params))

        @staticmethod
        def lineBreakMode(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.lineBreakMode(*params))

        @staticmethod
        def scroll(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.scroll(*params))

        @staticmethod
        def stopScroll():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.stopScroll())

        @staticmethod
        def drawDot(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.drawDot(*params))

        @staticmethod
        def drawLine(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.drawLine(*params))

        @staticmethod
        def drawRect(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.drawRect(*params))

        @staticmethod
        def drawCircle(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.drawCircle(*params))

        @staticmethod
        def drawTriangle(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Oled.drawTriangle(*params))

    class RadioMesh:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.RadioMesh.init(*params))

        @staticmethod
        def send(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.RadioMesh.send(*params))

        @staticmethod
        def getReceivedMsg():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.RadioMesh.getReceivedMsg())
            return _V.wizSerial.getData()

        @staticmethod
        def clearMsg():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.RadioMesh.clearMsg())

    class Servo:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Servo.init(*params))

        @staticmethod
        def setAngle(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Servo.setAngle(*params))

        @staticmethod
        def setVelocity(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Servo.setVelocity(*params))

    class WaterPump:
        @staticmethod
        def init():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.WaterPump.init())

        @staticmethod
        def run(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.WaterPump.run(*params))

    class Propeller:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Propeller.init(*params))

        @staticmethod
        def run(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Propeller.run(*params))

    class Vibrator:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Vibrator.init(*params))

        @staticmethod
        def run(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Vibrator.run(*params))

    class DcMotor:
        @staticmethod
        def init():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DcMotor.init())

        @staticmethod
        def run(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DcMotor.run(*params))

    class DotMatrix:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.init(*params))

        @staticmethod
        def printStr(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.printStr(*params))

        @staticmethod
        def clearMatrix(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.clearMatrix(*params))

        @staticmethod
        def clearMatrixAll():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.clearMatrixAll())

        @staticmethod
        def setLine(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.setLine(*params))

        @staticmethod
        def setDot(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.setDot(*params))

        @staticmethod
        def setBrightness(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.setBrightness(*params))

        @staticmethod
        def setLimit(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.setLimit(*params))

        @staticmethod
        def setShutdown(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DotMatrix.setShutdown(*params))

    class NeoPixel:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.NeoPixel.init(*params))

        @staticmethod
        def setBrightness(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.NeoPixel.setBrightness(*params))

        @staticmethod
        def setColor(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.NeoPixel.setColor(*params))

        @staticmethod
        def setColorAll(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.NeoPixel.setColorAll(*params))

    class Laser:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Laser.init(*params))

        @staticmethod
        def run(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Laser.run(*params))

    class Mesh:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Mesh.init(*params))

        @staticmethod
        def send(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Mesh.send(*params))

        @staticmethod
        def isReceived(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Mesh.isReceived(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def getReceivedMsg():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Mesh.getReceivedMsg())
            return _V.wizSerial.getData()

        @staticmethod
        def isConnected():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Mesh.isConnected())
            return _V.wizSerial.getData()

        @staticmethod
        def clearMsg():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Mesh.clearMsg())

    class InfraredThermometer:
        @staticmethod
        def read(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.InfraredThermometer.read(*params))
            return _V.wizSerial.getData()

    class DHT:  # Digital Humidity Temperature
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DHT.init(*params))

        @staticmethod
        def isConnected():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DHT.isConnected())
            return _V.wizSerial.getData()

        @staticmethod
        def readHumidity():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DHT.readHumidity())
            return _V.wizSerial.getData()

        @staticmethod
        def readTemperature(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.DHT.readTemperature(*params))
            return _V.wizSerial.getData()

    class HuskyLens:
        @staticmethod
        def init():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.init())

        @staticmethod
        def setMode(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.setMode(*params))

        @staticmethod
        def update():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.update())

        @staticmethod
        def isLearned(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.isLearned(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def isDetected(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.isDetected(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def getCountDetected():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.getCountDetected())
            return _V.wizSerial.getData()

        @staticmethod
        def isDetectedType(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.isDetectedType(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def getArrowInfo(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.getArrowInfo(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def getBoxInfo(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.getBoxInfo(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def drawText(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.drawText(*params))

        @staticmethod
        def clearText():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.HuskyLens.clearText())

    class Button:
        @staticmethod
        def read(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Button.read(*params))
            return _V.wizSerial.getData()

    class PhotoInterrupter:
        @staticmethod
        def read(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.PhotoInterrupter.read(*params))
            return _V.wizSerial.getData()

    class WaterSensor:
        @staticmethod
        def read(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.WaterSensor.read(*params))
            return _V.wizSerial.getData()

    SoilMoistureSensor = WaterSensor

    class Potentiometer:
        @staticmethod
        def read(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.PhotoInterrupter.read(*params))
            return _V.wizSerial.getData()

    class ColorSensor:
        @staticmethod
        def isColor(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.ColorSensor.isColor(*params))
            return _V.wizSerial.getData()

        @staticmethod
        def getColorValue(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.ColorSensor.getColorValue(*params))
            return _V.wizSerial.getData()

    class Joystick:
        @staticmethod
        def init(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Joystick.init(*params))

        @staticmethod
        def readStick(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Joystick.readStick(*params))
            return _V.wizSerial.getData()

        @staticmethod
        # Joystick.readButton() -- write(...)와 사용할 것
        def readButton():
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.Joystick.readButton())
            return _V.wizSerial.getData()

    class PortManager:
        @staticmethod
        def usePin(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.PortManager.usePin(*params))

        @staticmethod
        def digitalWrite(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.PortManager.digitalWrite(*params))

        @staticmethod
        def analogWrite(*params):
            if _V.wizSerial is None:
                raise RuntimeError("Must be connected to CodeWiz")
            _V.wizSerial.write(WizData.PortManager.analogWrite(*params))
